public class FruchtTest
{
	public static void main (String args[])
	{
		// geht nicht mehr, da Frucht abstract...
		// Frucht f = new Frucht( true, 800, 2 );
		// System.out.println( "f hat " + f.berechneVitaminC() );
		
		Apfel a = new Apfel( "Boskop", true, 800, 2 );
		System.out.println( "a hat " + a.berechneVitaminC() );
		
		Artikel art;
		
		Apfel aa = new Apfel( "BioApfel", true, 800, 2 );
		art = a; // Apfel ist ein Artikel
		System.out.println( "aa hat " + aa.berechneVitaminC() );
		
		// WIR wissen, dass in art ein Apfel ist. Der Compiler
		// weiss es nicht. Wir knnen es ihm aber sagen!!!
		Apfel c = (Apfel) art; // "explicit CAST" -> geht gut

		Banane b =  new Banane( true, 1000, 4 );
		art = b; // Banane ist auch ein Artikel
		System.out.println( art.getEAN()+ " hat " + b.berechneVitaminC() );
		
		// WIR wissen, dass in art nun eine Banane ist.
		
		// Apfel d = (Apfel) art; 
													 // "explicit CAST" -> geht nicht gut, da in art eine Banane steckt
													 // wird allerdings vom Compiler noch NICHT angemeckert, sondern eine
													 // ClassCastException
													 
		// primitives type cast
		long l = 1000; 
		int i = (int)l; // "explicit downcast" kann in die Hose gehen 
		long l2 = i;    // "implicit upcast" geht immer gut
		
		int q1 = (10/3) * 10;
		int q2 = (int) ( ((float)(10) /3 ) * 10);
		int q3 = (int) ((10.0/3) * 10);
		System.out.println( q1 + ",  " + q2 + ", " + q3 );
	}
}