/**
*	Bildet einen Apfel nach
*	@ author HaJo Rode
*/
public class Apfel extends Frucht
{
	protected String sorte;
	protected Kernhaus haus;
	
	public Apfel( String dieSorte, boolean istEssbar, int vitc, int gr )
	{
		super( istEssbar, vitc, gr );
		sorte = dieSorte;
	}
	public Apfel()
	{
		this( "unbekannt", false, 0, 0 );
	}
	
	public String Apfelsorte()
	{
		return sorte;
	}
	
	public int berechneVitaminC()
	{
		int gehalt = super.berechneVitaminC();
		// hier knnen Probleme auftauchen wegen Stringvergleich bzw. Adressvergleich im Speicher
		// bad
		// if ( sorte == "BioApfel") 
		// good
		if ("BioApfel".equals(sorte) ) // !!!! nicht mit == vergleichen
		{
			return (int)(gehalt * 1.15);
		}
		return gehalt;
	}	
	public String getEAN()
	{
		return "1-APF-EL";
	}
	public int getPrice()
	{
		return 102;
	}

}
/*
String s1 = "Bio", s2 = "Bio";
if ( s1 == s2 ) ...

!!! hier macht der Javacompiler keine 2 Adressen...

String s1 = "B"+"io", 
       s2 = "Bi"+"o"
!!! hier macht er 2 Adressen und somit schlgt
   if ( s1 == s2 ) ...
fehl

daher besser
	if ( s1.equals(s2) ) ...
	oder
	if ( s1.equalsIgnoreCase(s2) ) ...

*/